﻿BabelFu = LibStub("AceAddon-3.0"):NewAddon("FuBar_BabelFu", "AceHook-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QT = LibStub:GetLibrary( "LibQTip-1.0" )

---------------------------------------------
-- CONSTANTS                               --
---------------------------------------------
local defaults = {
	char = {
		language = 1,
		types = {
			["SAY"] = true,
			["YELL"] = true,
			["PARTY"] = true,
			["GUILD"] = true,
			["OFFICER"] = true,
			["RAID"] = true,
		}
	}
}

local tooltip = nil

local launcher = ldb:NewDataObject( "BabelFu", {
	type = "data source",
	text = " ",
	label = "BabelFu",
	icon = "Interface\\Addons\\FuBar_BabelFu\\icon",
	OnClick = function(clickedframe, button)
		BabelFu_SelectLanguage(
		    ((BabelFu.db.char.language or 1) % GetNumLanguages()) + 1)
	end,
	OnEnter = function ( frame )
		tooltip = QT:Acquire( "BabelFuTT", 1, "CENTER" )
		BabelFu_DrawTooltip()
		tooltip:SetAutoHideDelay( .1 , frame )
		tooltip:EnableMouse()
		tooltip:SmartAnchorTo(frame)
		tooltip:Show()
	end,
	OnLeave = function()
		-- Just return, AutoHideDelay has it covered.
		return
	end,
} )

---------------------------------------------
-- EVENTS                                  --
---------------------------------------------
function BabelFu:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BabelFuDB", defaults)
end

function BabelFu:OnEnable()
	self:RawHook("SendChatMessage","Translate",true)
	launcher.text = GetLanguageByIndex(BabelFu.db.char.language or 1)
end


----------------------------------------------
-- METHODS                                  --
----------------------------------------------
function BabelFu:Translate(msg, chatType, language, channel)
	if (chatType and self.db.char.types[chatType]) then
		language = GetLanguageByIndex(self.db.char.language)
	end
	self.hooks.SendChatMessage(msg,chatType,language, channel)
end

-----------------------------------------------
-- FUNCTIONS                                 --
-----------------------------------------------

function BabelFu_SelectLanguage(index)
	assert(index <= GetNumLanguages(), "Bad language chosen: " .. index)
	BabelFu.db.char.language = index
	launcher.text = GetLanguageByIndex(index)
end

function BabelFu_DrawTooltip()
	tooltip:Hide()
	tooltip:Clear()

	tooltip:AddHeader("BabelFu")

	for x=1, GetNumLanguages() do
		tooltip:AddLine(GetLanguageByIndex(x))
		tooltip:SetLineScript(tooltip:GetLineCount(),"OnMouseUp",
		    BabelFu_SelectLanguage, x)
	end
end

